# K230 CanMV GPIO API手册

![cover](../images/canaan-cover.png)

版权所有©2023北京嘉楠捷思信息技术有限公司

<div style="page-break-after:always"></div>

## 免责声明

您购买的产品、服务或特性等应受北京嘉楠捷思信息技术有限公司（“本公司”，下同）及其关联公司的商业合同和条款的约束，本文档中描述的全部或部分产品、服务或特性可能不在您的购买或使用范围之内。除非合同另有约定，本公司不对本文档的任何陈述、信息、内容的正确性、可靠性、完整性、适销性、符合特定目的和不侵权提供任何明示或默示的声明或保证。除非另有约定，本文档仅作为使用指导参考。

由于产品版本升级或其他原因，本文档内容将可能在未经任何通知的情况下，不定期进行更新或修改。

## 商标声明

![logo](../images/logo.png)、“嘉楠”和其他嘉楠商标均为北京嘉楠捷思信息技术有限公司及其关联公司的商标。本文档可能提及的其他所有商标或注册商标，由各自的所有人拥有。

**版权所有 © 2023北京嘉楠捷思信息技术有限公司。保留一切权利。**
非经本公司书面许可，任何单位和个人不得擅自摘抄、复制本文档内容的部分或全部，并不得以任何形式传播。

<div style="page-break-after:always"></div>

## 目录

[TOC]

## 前言

### 概述

本文档主要介绍 canmv中GPIO的使用

### 读者对象

本文档（本指南）主要适用于以下人员：

- 技术支持工程师
- 软件开发工程师

### 缩略词定义

| 简称 | 说明 |
| ---- | ---- |
| GPIO  |  General Purpose Input Output （通用输入/输出）  |

### 修订记录

| 文档版本号 | 修改说明 | 修改者     | 日期       |
| ---------- | -------- | ---------- | ---------- |
| V1.0       | 初版     | 史文涛      | 2023-09-20 |

## 1. 概述

GPIO提供了设置gpio模式及引脚状态，并可配置pin的中断模式

## 2. API描述

GPIO提供了一个类GPIO，实现了四个函数，设置引脚状态value([value]),设置GPIO输入输出模式mode(MODE),
配置中断和关闭中断。

### 2.1 类 machine.GPIO

【描述】

通过指定的参数新建一个 GPIO 对象。

【语法】

```python
from machine import GPIO
gpio = GPIO(ID, MODE, PULL, VALUE)
```

【参数】

| 参数名称        | 描述                          | 输入/输出 |
|-----------------|-------------------------------|-----------|
| ID  |  使用的 GPIO 引脚。            | 输入      |
| GPIO模式  |  GPIO模式，GPIO.IN就是输入模式,GPIO.OUT就是输出模式            | 输入      |
| PULL  |  GPIO上下拉模式，GPIO.PULL_UP 上拉,GPIO.PULL_DOWN 下拉, GPIO.PULL_NONE 即不上拉也不下拉       | 输入      |
| VALUE  |  修改GPIO引脚状态。            | 输入      |

【返回值】

| 返回值  | 描述                            |
|---------|---------------------------------|
| 0       | 成功                          |
| 非 0    | 失败 |

【注意】

无

【举例】

无

【相关主题】

无

#### 2.1.1 value([value])

【描述】

修改/读取 GPIO 引脚状态。

【语法】

```python
GPIO.value([value])
```

【参数】

| 参数名称        | 描述                          | 输入/输出 |
|-----------------|-------------------------------|-----------|
| [value]  | 可选参数，如果此参数不为空，则返回当前 GPIO 引脚状态  | 输入      |

【返回值】

| 返回值  | 描述                            |
|---------|---------------------------------|
| 0       | 成功                          |
| 非 0    | 失败 |

【注意】

无

【举例】

无

【相关主题】

无

#### 2.1.2 mode(MODE)

【描述】

设置 GPIO 输入输出模式

【语法】

```python
GPIO.mode(MODE)
```

【参数】

MODE

• GPIO.IN 输入模式

• GPIO.PULL_UP 上拉输入模式

• GPIO.PULL_DOWN 下拉输入模式

• GPIO.OUT 输出模式

【返回值】

| 返回值  | 描述                            |
|---------|---------------------------------|
| 0       | 成功                          |
| 非 0    | 失败 |

【注意】

无

【举例】

无

【相关主题】

无

#### 2.1.3 irq

【描述】

配置一个中断处理程序，当 pin 的触发源处于活动状态时调用它。如果管脚模式为 pin.in，则触发源是管脚上的外部值。

【语法】

```python
GPIO.irq(CALLBACK_FUNC,TRIGGER_CONDITION,GPIO.WAKEUP_NOT_SUPPORT,PRORITY)
```

【参数】

​• CALLBACK_FUNC：中断回调函数，当中断触发的时候被调用，一个入口函数 pin_num

​• PIN_NUM 返回的是触发中断的 GPIO 引脚号(只有GPIOHS支持中断，所以这里的引脚号也是GPIOHS的引脚号)

​• TRIGGER_CONDITION：GPIO 引脚的中断触发模式

​• GPIO.IRQ_RISING 上升沿触发

​• GPIO.IRQ_FALLING 下降沿触发

​• GPIO.IRQ_BOTH 上升沿和下降沿都触发

【返回值】

| 返回值  | 描述                            |
|---------|---------------------------------|
| 0       | 成功                          |
| 非 0    | 失败 |

【注意】

无

【举例】

无

【相关主题】

无

#### 2.1.4 disirq

【描述】

关闭中断

【语法】

```python
GPIO.disirq()
```

【参数】

无

【返回值】

| 返回值  | 描述                            |
|---------|---------------------------------|
| 0       | 成功                          |
| 非 0    | 失败 |

【注意】

无

【举例】

无

【相关主题】

无
